<?php
/*
 * Name:      Details
 * Directory: details
 * Version:   0.1.0
 * Type:      user
 * UI Name:   Deatils
 * UI Icon: details.png
 *
	 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
	 * Developed by Christian Kien																					*
	 *	In cooperation with Jose Grincho, PCMO																		*
	 * 	European Investment Fund																				*
	 *																									*
	 *	www.EIF.org																						*
	 *	c.kien@eif.org																						*
	 *	j.grincho@eif.org																						*
	 *																									*
	 *	Suggestions, questions or criticism welcome! Please e-mail us!															*
	 *	Please read the readme.txt																				*
	 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 *
 * Adds some fields to projects
 *DONT FORGET TO MODIFY do_project_aed.php of projects as described in the readme
 *
 */

// MODULE CONFIGURATION DEFINITION
$config = array();
$config['mod_name'] = 'Details';				// name the module
$config['mod_version'] = '0.1.0';					// add a version number
$config['mod_directory'] = 'details';			// tell dotProject where to find this module
$config['mod_setup_class'] = 'CSetupDetails';	// the name of the PHP setup class (used below)
$config['mod_type'] = 'user';						// 'core' for modules distributed with dP by standard, 'user' for additional modules from dotmods
$config['mod_ui_name'] = 'Details';				// the name that is shown in the main menu of the User Interface
$config['mod_ui_icon'] = 'details.png';						// name of a related icon
$config['mod_description'] = 'Details';			// some description of the module
$config['mod_config'] = false;						// show 'configure' link in viewmods

// show module configuration with the dPframework (if requested via http)
if (@$a == 'setup') {
	echo dPshowModuleConfig( $config );
}

class CSetupDetails {

	function remove() {		// run this method on uninstall process
		db_exec( "DROP TABLE details;" );	// remove the pcmc table from database
		db_exec( "DROP TABLE details_histories;" );	// remove the pcmc table from database
		return null;
	}

	function install() {
		$sql = "CREATE TABLE details ( " .					// prepare the creation of a dbTable
			"  detail_id int(11) unsigned NOT NULL auto_increment" .  // better to use the store procedure of the main class. Therefor need own id! dont use foreign!!
			", detail_project int(11) unsigned NOT NULL" .
			", detail_lupdate TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP" .
			", detail_cdate DATE NOT NULL" .
			", detail_bcase TEXT NULL DEFAULT NULL" .
			", detail_aap TEXT NULL DEFAULT NULL" .
			", detail_aapobservations TEXT NULL DEFAULT NULL" .
			", detail_bpm INT(11) NULL DEFAULT NULL" .
			", detail_bsponsor int(11) NULL DEFAULT NULL" .
			", detail_csfactor TEXT NULL DEFAULT NULL" .
			", detail_team TEXT NULL DEFAULT NULL" .
			", detail_milestone TEXT NULL DEFAULT NULL" .
			", detail_budget TEXT NULL DEFAULT NULL" .
			", detail_governance TEXT NULL DEFAULT NULL" .
			", detail_system TEXT NULL DEFAULT NULL" .   //multiselection			
			", detail_strategy TINYINT NULL DEFAULT '1' ".
			", detail_sholders TINYINT NULL DEFAULT '1' ".
			", detail_risks TINYINT NULL DEFAULT '1' ".
			", detail_sizing TINYINT NULL DEFAULT '1' ".
			", detail_horizontality TINYINT NULL DEFAULT '1' ".
			", detail_costbenefit TINYINT NULL DEFAULT '1' ".
			", detail_rationale TEXT NULL ".
			", detail_int_team TEXT NULL ".
			", detail_must_rationale TEXT NULL ".
			", detail_unique_identifier TEXT NULL ".
			", detail_must TINYINT NULL DEFAULT NULL ".
			", PRIMARY KEY  (detail_id)" .
			", UNIQUE KEY detail_id (detail_project)" .
			") TYPE=MyISAM;";

		db_exec( $sql ); db_error();						// execute the queryString
		$sql = "CREATE TABLE IF NOT EXISTS details_projects ( ".
				"detail_project_id int(11) NOT NULL auto_increment, ".
				"detail_project_link1 int(11) NOT NULL, ".
				"detail_project_link2 int(11) NOT NULL, ".
				"detail_project_description text, ".
				"PRIMARY KEY  (detail_project_id) ".
				") ENGINE=MyISAM ;";

		db_exec( $sql ); db_error();						// execute the queryString
		
		// Creating the history table for the "6Values"
		
		$sql = " CREATE TABLE details_histories (
				  detail_history_id int(11) NOT NULL auto_increment,
				  detail_history_project int(11) NOT NULL,
				  detail_history_lupdate timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
				  detail_history_strategy tinyint(4) NOT NULL,
				  detail_history_sholders tinyint(4) NOT NULL,
				  detail_history_risks tinyint(4) NOT NULL,
				  detail_history_sizing tinyint(4) NOT NULL,
				  detail_history_horizontality tinyint(4) NOT NULL,
				  detail_history_costbenefit tinyint(4) NOT NULL,
				  detail_history_rationale text character set latin1 collate latin1_bin,
				  detail_history_user_id int(11) default NULL,
				  detail_history_bpm int(11) default NULL,
				  detail_history_aap text,
				  detail_history_aapobservation text,
				  detail_history_bcase text,
				  detail_history_csfactor text,
				  detail_history_team text,
				  detail_history_milestone text,
				  detail_history_budget text,
				  detail_history_governance text,
				  detail_history_cdate date default NULL,
				  detail_history_system text,
				  detail_history_bsponsor text,
				  detail_history_int_team text,
				  detail_history_must tinyint(4) default NULL,
				  detail_history_must_rationale text,
				  detail_history_unique_identifier TEXT NULL,
				  PRIMARY KEY  (detail_history_id)
				) ENGINE=MyISAM DEFAULT CHARSET=latin1 ; ";

		db_exec( $sql ); db_error();						// execute the queryString

		//inserting some extra sysvals
		//$sql = 'INSERT INTO sysvals ( sysval_key_id, sysval_title, sysval_value ) ' .
		$sql = 'REPLACE INTO sysvals ( sysval_key_id, sysval_title, sysval_value ) ' .
			   'VALUES ( ' .
			   ' "1","OpportunitiesPriorities","1|- \n2|Must \n3|High \n4|Medium \n5|Low \n6|Option" ' .
			   ' ) , ( ' .
			  // ' "1","OpportunitiesContexts","1|- \n2|Institution \n3|Management \n4|Front Office \n5|Middle Office \n6|Back Office \n7|Support" ' .			   
			  // ' ) , ( ' .
			   ' "1","OpportunitiesSizings","1|- \n2|XLarge \n3|Large \n4|Medium \n5|Small \n6|XSmall" ' .			   
			   ' ) , ( ' .
			   ' "1","OpportunitiesStatus","1|Open \n2|Analysis \n3|ToProject \n4|Archieved" ' .			   
			   ' ) , ( ' .
			   ' "1","OpportunitiesPoints","0|0 \n1|1 \n2|2 \n3|3 \n4|4 \n5|5" ' .
			   ' ) , ( ' .
			   ' "1","OpportunitiesYesNo","1|no \n2|yes" ' .
			   ' ) , ( ' .
//			   ' "1","OpportunitiesPM","1|- \n2|Abdel \n3|Jose \n4|Monica \n5|Silvia \n6|Sophie" ' .
//			   ' ) , ( ' .
			   ' "1","OpportunitiesBA","1|- \n2|FIN \n3|MIS \n4|VC \n5|GS \n6|OTH \n7|LO" ' .
			   ');';
		db_exec( $sql ); db_error();						// execute the queryString		
		
		return null;
	}
	
	function upgrade() {
		return null;
	}
}

?>