<?php /* PROJECTS $Id: addedit.php,v 1.56 2003/09/11 02:47:22 gregorerhardt Exp $ */
if (! defined('DP_BASE_DIR')) {
	die('You should not access this file directly');
}

$invoice_id = intval(dPgetParam($_REQUEST, "invoice_id", 0));
$project_id = intval(dPgetParam($_REQUEST, "project_id", 0));

$completeTasks = $INVOICE_CONFIG['complete_tasks_only']; // Show tasklogs only for completed tasks.


// check permissions for this record
// Done automatically in index.php
//$canEdit = !getDenyEdit( $m, $project_id);
if (!$canEdit) {
	$AppUI->redirect("m=public&a=access_denied");
}

// format dates
$df = $AppUI->getPref('SHDATEFORMAT');

$start_date = new CDate($row->project_start_date);

$end_date = intval($row->project_end_date) ? new CDate($row->project_end_date) : null;
$actual_end_date = intval($row->project_actual_end_date) ? new CDate($row->project_actual_end_date) : null;

// setup the title block
$ttl = $invoice_id > 0 ? "Edit Invoice" : "New Invoice";
$titleBlock = new CTitleBlock($ttl, 'applet3-48.png', $m, "$m.$a");
$titleBlock->addCrumb("?m=projects", "projects list");
if ($project_id != 0)
	$titleBlock->addCrumb("?m=projects&a=view&project_id=$project_id", "view this project");
$titleBlock->addCrumb('?m=invoice', 'view all invoices');
$titleBlock->addCrumb('?m=invoice&a=view&project_id=' . $project_id . '&invoice_id=' . $invoice_id, 'view this invoice');
if ($invoice_id > 0) {
	$titleBlock->addCrumbDelete('Delete Invoice');
}
$titleBlock->show();

/////// Make sure a project is selected
if ($project_id == 0) {
	include_once $baseDir.'/modules/projects/projects.class.php';
	$projects = new CProject();
	$projects = $projects->getAllowedProjectsInRows($AppUI->user_id);
	
	echo '
	Select project:
	<form action="?m=invoice&a=addedit" method="post">
	<select name="project_id" onchange="this.form.submit()">
	<option value="">[Select]</option>
	';
	foreach ($projects as $project) { 
		echo '<option value="'.$project['project_id'].'">'.$project['project_name'].'</option>';
	} 
	echo '</select></form>'; 
	exit;
}


$task_id = (int) $_REQUEST["task_id"];
if ($task_id == '') {
	$task_id = 0;
}

$q = new DBQuery();
$q->addQuery('task_log_id');
$q->addTable('invoice_task_queue');
$temp_billed = db_loadColumn($q->prepare());
$billed = '';
foreach ($temp_billed as $task_log)
	$billed .= $task_log . ', ';
if (!empty($billed))
	$billed = '(' . substr($billed, 0, - 2) . ')';

$q->clear();
$q->addQuery('
	task_log.task_log_id as task_log_id,
	task_log_task,
	task_log_name,
	task_log_description,
	task_log_creator,
	task_log_hours,
	task_log_date,
	tasks.task_id,
	tasks.task_name,
	tasks.task_target_budget,
	billingcode_name');
$q->addTable('task_log');
$q->addTable('tasks');
$q->addTable('projects');
$q->leftJoin('billingcode', 'b', 'billingcode_id = task_log_costcode');
$q->addWhere('tasks.task_project = project_id');
if (!empty($billed))
	$q->addWhere('task_log_id not in ' . $billed);
$q->addWhere('tasks.task_id = task_log_task');
$q->addWhere('task_log_hours > 0');
if ($completeTasks)
	$q->addWhere('tasks.task_percent_complete = 100');
$q->addWhere('project_id = ' . $project_id);

if (!empty($_POST["start_date"])) {
	$actual_start_date = strtotime($_REQUEST["start_date"]);
	$start_date = new CDate($actual_start_date);
	$q->addWhere('task_log_date > \'' . $_REQUEST['inv_start_date'] . "'");
}
if (! empty($_POST['end_date'])) {
	$actual_end_date = strtotime($_REQUEST["end_date"]);
	$end_date = new CDate($actual_end_date);
	$q->addWhere("task_log_date < '" . $_REQUEST['inv_end_date'] . "' ");
}
if ($task_id != 0)
	$q->addWhere('task_log_task = ' . $task_id);
	
//$q->addOrder('task_log_name');
$tasks_log = $q->loadList();

$q->clear();
$q->addQuery('
	task_queue_id,
	task_log_id,
	task_amount');
$q->addQuery('item_description');
$q->addTable('invoice_task_queue');
$q->addWhere('task_invoice = ' . $invoice_id);
$q->addOrder('task_log_id DESC');
$tasks = $q->loadList();

$q->clear();
$q->addQuery('task_id, task_name');
$q->addTable('tasks');
$q->addTable('task_log');
$q->addWhere('task_id = task_log_task');
if (!empty($billed))
	$q->addWhere('task_log_id not in ' . $billed);
	//AND task_percent_complete  > 0
$q->addWhere('task_project = ' . $project_id);
$q->addGroup('task_id HAVING count(task_log_task) > 0 AND sum(task_log_hours) > 0');
$q->addOrder('task_name ASC');

$task_list = array("0" => "Select Task");
$ptrc = $q->exec();
$nums = db_num_rows($ptrc);

for ($x = 0; $x < $nums; $x ++) {
	$row = db_fetch_assoc($ptrc);
	$task_list[$row["task_id"]] = $row["task_name"];
}

$q->clear();
$q->addQuery('project_company');
$q->addTable('projects');
$q->addWhere('project_id = ' . $project_id);

$company_id = $q->loadResult();

$q->clear();
$q->addQuery('
        billingcode_id,
        billingcode_name,
        billingcode_value');
$q->addTable('billingcode');
$q->addWhere('(company_id = 0 OR company_id = ' . $company_id . ')');
$q->addOrder('billingcode_name ASC');

$billingcodes = $q->loadList();

function show_invoice_task (&$a)
{
	global $AppUI, $project_id, $billingcodes;
	$df = $AppUI->getPref('SHDATEFORMAT');
	
	$q = new DBQuery();
	if ($a['task_log_id'] != 0) {
		$q->addQuery('
						task_log_id,
						task_log_task,
						task_log_name,
						task_log_description,
						task_log_costcode,
						task_log_creator,
						task_log_hours,
						task_log_date,
						task_log_task');
		$q->addTable('task_log');
		$q->addWhere('task_log_id = ' . $a['task_log_id']);
		$q->addOrder('task_log_name ASC');
		
		$tmptasks = $q->exec();
		$tasks = db_fetch_assoc($tmptasks);
		
		$q->clear();
		
		$username = dPgetUsername($tasks['task_log_creator']);
	}
	
	if ($a["task_amount"] == "0") {
		$costdesc = "None";
		for ($x = 0; $x < count($billingcodes); $x ++) {
			if ($billingcodes[$x]["billingcode_id"] == $tasks["task_log_costcode"]) {
				$costdesc = $billingcodes[$x]["billingcode_name"];
				$rate = $billingcodes[$x]["billingcode_value"];
			}
		}
		$amount = round($rate * $tasks["task_log_hours"], 2);
	} else {
		$costdesc = "Fixed Price";
		$amount = round($a["task_amount"], 2);
	}
	
	$s = "\n<tr>";
	if ($a['task_log_id'] != 0)
		$s .= '<td><a href="./index.php?m=tasks&a=view&task_id=' . $tasks["task_log_task"] . '"><img src="./images/icons/pencil.gif" border="0" alt="Edit"></a></td>';
	else
		$s .= '<td>&nbsp;</td>';
	$s .= "<td><a href=\"javascript:delIt2({$a['task_queue_id']});\" title=\"" . $AppUI->_('delete') . "\"><img src=\"./images/icons/stock_delete-16.png\" border=\"0\" alt=\"Delete\"></a></td>";
	$tdate = new CDate($tasks['task_log_date']);
	$s .= '<td nowrap align="center">' . $tdate->format($df) . '</td>';
	$alt = htmlspecialchars($tasks["task_log_name"]);
	if ($a['task_log_id'] != 0)
		$s .= '<td align=left>&nbsp;<a href="./index.php?m=tasks&a=view&task_id=' . $tasks["task_log_task"] . '" title="' . $alt . '">' . $tasks["task_log_name"] . '</a></td>';
	else
		$s .= '<td>' . $a['item_description'] . '</td>';
	$s .= '<td nowrap="nowrap" align=center>' . $username . '</td>';
	$s .= '<td nowrap="nowrap" align=center>' . $tasks["task_log_hours"] . '</td>';
	$s .= '<td nowrap="nowrap">' . $costdesc . '</td>';
	$s .= '<td nowrap="nowrap">' . dPgetConfig('currency_symbol') . $amount . '</td>';
	$s .= '</tr>';
	if ($a['task_log_id'] != 0) {
		$s .= '<tr>';
		$s .= '<td colspan="2">&nbsp;</td>';
		$s .= '<td colspan="6">';
		$s .= $tasks["task_log_description"];
		$s .= '</td>';
		$s .= "</tr>\n";
	}
	echo $s;
	
	return $amount;
}

function showtasklog (&$a)
{
	global $AppUI, $project_id;
	$df = $AppUI->getPref('SHDATEFORMAT');
	
	$q = new DBQuery();
	$q->addQuery('contact_first_name, contact_last_name');
	$q->addTable('contacts');
	$q->leftJoin('users', 'u', 'user_contact = contact_id');
	$q->addWhere('user_id = ' . $a['task_log_creator']);
	
	$tmpuser = $q->exec();
	$username = db_fetch_assoc($tmpuser);
	
	$q->clear();
	$q->addQuery('task_invoice');
	$q->addTable('invoice_task_queue');
	$q->addWhere('task_log_id = ' . $a['task_log_id']);
	
	$tmpcheck = $q->exec();
	$check = db_fetch_assoc($tmpcheck);
	
	$date = new CDate($a['task_log_date']);
	$s = '
	<tr valign="top">
		<td><input type="checkbox" name="num[]" value="' . $a["task_log_id"] . '"></td>
		<td nowrap>' . $date->format($df) . '</td>
		<td><a href="./index.php?m=tasks&a=view&task_id='.$a['task_id'].'">' . $a['task_name'] . '</a></td>
		<td>' . $a["task_log_description"] . '</td>
		<td nowrap>' . $username["contact_first_name"] . ' ' . $username["contact_last_name"] . '</td>
		<td nowrap>' . $a['task_log_hours'] . '</td>
		<td nowrap>' . $a['billingcode_name'] . '</td>
		<td align="right" nowrap="nowrap">$<input type="text" name="fixed_' . $a['task_log_id'] . '" size="6" value="'.$a['task_target_budget'].'">
	</tr>
	';
	if (trim($check['task_invoice']) == '') {
		echo $s;
	}
}

$q->addQuery('*');
$q->addTable('invoice');
$q->addWhere('invoice_id = ' . $invoice_id);
list ($invoice) = $q->loadList();

if (empty($invoice['invoice_contact'])) {
	$q->addQuery('invoice_name');
	$q->addTable('invoice_company');
	$q->addWhere('invoice_company = ' . $company_id);
	$invoice['invoice_contact'] = $q->loadResult();
}

?>
<link rel="stylesheet" type="text/css" media="all" href="lib/calendar/calendar-dp.css" title="blue" />
<!-- import the calendar script -->
<script type="text/javascript" src="<?php echo DP_BASE_URL; ?>lib/calendar/calendar.js"></script>
<!-- import the language module -->
<script type="text/javascript" src="<?php echo DP_BASE_URL; ?>lib/calendar/lang/calendar-<?php echo $AppUI->user_locale; ?>.js"></script>

<script type="text/javascript">
<!--
function submitIt() {
	var f = document.editFrm;
	var msg = '';

	if (msg.length < 1) {
		f.submit();
	} else {
		alert(msg);
	}
}

function delIt(id) {
	if (confirm( "<?php echo $AppUI->_('doDelete', UI_OUTPUT_JS) . ' ' . $AppUI->_('Invoice', UI_OUTPUT_JS) . '?';	?>" )) {
		document.frmDelete.submit();
	}
}

function delIt2(id) {
	if (confirm( "<?php echo $AppUI->_('doDelete', UI_OUTPUT_JS) . ' ' . $AppUI->_('Invoice Item', UI_OUTPUT_JS) . '?';	?>" )) {
		document.frmDelete2.task_queue_id.value = id;
		document.frmDelete2.submit();
	}
}

function changeIt() {
	var f = document.changeMe;
	f.submit();
}

function searchIt() {
	document.searchMe.submit();
}

function changeStat() {
	var f=document.frmStatus;
	f.submit();
}

var calendarField = '';
var calWin = null;

function popCalendar( field ){
	var calendarField = field;
	var idate = eval( 'document.searchMe.' + field + '.value' );
	window.open( 'index.php?m=public&a=calendar&dialog=1&callback=setCalendar&date=' + idate, 'calwin', 'top=250,left=250,width=250, height=220, scollbars=false' );
}

/**
 *      @param string Input date in the format YYYYMMDD
 *      @param string Formatted date
 */
function setCalendar(idate, fdate) {
	var fld_date = eval('document.searchMe.inv_' + calendarField);
	var fld_fdate = eval('document.searchMe.' + calendarField);
	fld_date.value = idate;
	fld_fdate.value = fdate;
}

function checkUncheckAll(theElement) {
 //documentation for this script at http://www.shawnolson.net/a/693/
	var theForm = theElement.form;
	var z = 0;
	while (theForm[z].name != 'checkall') 
	{
		if (theForm[z].type == 'checkbox')
			theForm[z].checked = theElement.checked;
		z++;
	}
}
-->
</script>

<table border="0" cellpadding="4" cellspacing="0" width="100%" class="std">
	<form name="frmDelete2" action="./index.php?m=invoice" method="post">
		<input type="hidden" name="dosql" value="do_invoice_aed">
		<input type="hidden" name="del" value="1" />
		<input type="hidden" name="task_queue_id" value="0" />
		<input type="hidden" name="invoice_project" value="<?php echo $project_id ?>" />
		<input type="hidden" name="task_invoice" value="<?php echo $invoice_id ?>" />
	</form>
	<form name="frmDelete" action="./index.php?m=invoice" method="post">
		<input type="hidden" name="dosql" value="do_invoice_aed">
		<input type="hidden" name="delinvoice" value="1" />
		<input type="hidden" name="invoice_project" value="<?php echo $project_id ?>" />
		<input type="hidden" name="task_invoice" value="<?php echo $invoice_id ?>" />
	</form>

	<form name="statusFrm" action="./index.php?m=invoice" method="post">
		<input type="hidden" name="dosql" value="do_invoice_aed" />
		<input type="hidden" name="del" value="0" />
		<input type="hidden" name="invoice_project" value="<?php echo $project_id ?>" />
		<input type="hidden" name="task_invoice" value="<?php echo $invoice_id ?>" />
		<input type="hidden" name="invoice_id" value="<?php echo $invoice_id ?>" />
		<input type="hidden" name="project_creator" value="<?php echo $AppUI->user_id ?>" />

	<table cellspacing="0" cellpadding="4" border="0" width="40%" class="std" valign="top">
		<tr valign="top" width="90%">
			<td align="left">Invoices will not be editable once the status changes from Open for Editing.</td>
		</tr>
		<tr valign="top" width="90%">
			<td align="right">Invoice Status&nbsp;
	<?php
	$invoice_statuses = array(0 => 'Open for Editing' , 1 => 'Pending Payment' , 2 => 'Paid');
	echo arraySelect($invoice_statuses, 'invoice_status', 'size="1" class="text"', $invoice['invoice_status']);
	?>
	</td>
		</tr>
		<tr>
			<td align="right"><input class="button" type="submit" name="submit" value="<?php echo $AppUI->_('submit') ?>" /></td>
		</tr>
	</table>


	<br>


	<table width="100%" border="0" cellpadding="2" cellspacing="1" class="tbl">
		<tr>
			<th width="10">&nbsp;</th>
			<th width="15">&nbsp;</td>
			<th><?php echo $AppUI->_('Date'); ?></th>
			<th><?php echo $AppUI->_('Task Name'); ?></th>
			<th width="250" nowrap="nowrap"><?php echo $AppUI->_('Task Creator') ?></th>
			<th width="100" nowrap="nowrap"><?php echo $AppUI->_('Task Hours') ?></th>
			<th width="100" nowrap="nowrap"><?php echo $AppUI->_('Billing Code') ?></th>
			<th width="100" nowrap="nowrap"><?php echo $AppUI->_('Amount') ?></th>
		</tr>
<?php
$myamount = 0;
for ($s = 0; $s < count($tasks); $s ++) {
	$tnums = count($tasks);
	if ($tnums) {
		$tmpamount = 0;
		$tmpamount = show_invoice_task($tasks[$s], 1);
		$myamount = $myamount + $tmpamount;
	}
}
?>
		<tr>
			<td colspan="7" align="right"><b>Total</b></td>
			<td>
				<?php echo dPgetConfig('currency_symbol'); ?>
				<?php echo $myamount ?>
			</td>
		</tr>
	</table>

	<table class="tbl">
		<tr>
			<td><?php echo $AppUI->_('Invoice Contact') ?></td>
			<td><input class="text" type="text" name="invoice_contact" value="<?php
			echo $invoice['invoice_contact'];
			?>"></td>
		</tr>
		<tr>
			<td><?php echo $AppUI->_('Notes') ?></td>
			<td><textarea class="text" name="invoice_notes"><?php
			echo $invoice['invoice_notes'];
			?></textarea></td>
		</tr>
	</table>
	</form>

	<table cellspacing="0" cellpadding="4" border="0" width="70%" class="std">
		<tr valign="top" width="90%">

			<form name="searchMe" action="./index.php?m=invoice&a=addedit" method="post"><input type="hidden" name="invoice_project" value="<?php
			echo $project_id;
			?>" /> <input
				type="hidden" name="project_id" value="<?php
				echo $project_id;
				?>" /> <input type="hidden" name="invoice_id" value="<?php
				echo $invoice_id;
				?>" /> <input type="hidden"
				name="task_invoice" value="<?php
				echo $invoice_id;
				?>" /> <input type="hidden" name="project_creator" value="<?php
				echo $AppUI->user_id;
				?>" />
			<td align="right" nowrap="nowrap">
		<?php
		echo $AppUI->_('Start Date');
		?>
		<input type="hidden" name="inv_start_date" value="" class="text" /> <input type="text" name="start_date" value="" class="text" /> <a href="#" onclick="popCalendar('start_date')">
			<img src="./images/calendar.gif" width="24" height="12" alt="<?php
			echo $AppUI->_('Calendar');
			?>" border="0" /> </a></td>

			<td align="right" nowrap="nowrap">
		<?php
		echo $AppUI->_('End Date');
		?>
		<input type="hidden" name="inv_end_date" value="" class="text" /> <input type="text" name="end_date" value="" class="text" /> <a href="#" onclick="popCalendar('end_date')"> <img
				src="./images/calendar.gif" width="24" height="12" alt="<?php
				echo $AppUI->_('Calendar');
				?>" border="0" /> </a></td>
			<td><input class="button" type="button" name="btnFuseSearch" value="<?php
			echo $AppUI->_('search');
			?>" onclick="searchIt();" /></td>
		
		</tr>
		</form>

		<tr>
			<td align="right" nowrap="nowrap">
	<?php
	echo $AppUI->_('Task Name');
	?>
<form name="changeMe" action="./index.php?m=invoice&a=addedit" method="post">
	<input type="hidden" name="invoice_project" value="<?php echo $project_id; ?>" />
	<input type="hidden" name="project_id" value="<?php echo $project_id ?>" />
	<input type="hidden" name="invoice_id" value="<?php echo $invoice_id ?>" />
	<input type="hidden" name="task_invoice" value="<?php	echo $invoice_id ?>" />
	<input type="hidden" name="project_creator" value="<?php echo $AppUI->user_id ?>" />
	<?php echo arraySelect($task_list, 'task_id', 'size="1" class="text" onchange="changeIt();"', $obj->task_status, true); ?>
</form>
			</td>
		</tr>
		<tr>
			<td colspan="2" align="right"><input class="button" type="button" name="btnFuseAction" value="<?php
			echo $AppUI->_('Add selected tasks log to invoice');
			?>" onclick="submitIt();" />
			</td>
		</tr>
<?php
if (isset($_POST['start_date'])) {
	?>
<tr>
			<td colspan="2"><?php
	echo 'Dates between: ' . $_POST['start_date'] . ' and ' . $_POST['end_date'] . '<br />'?></td>
		</tr>;
<?php
}
?>
</table>
	<form name="editFrm" action="./index.php?m=invoice" method="post"><input type="hidden" name="dosql" value="do_invoice_aed" />
		<input type="hidden" name="invoice_project" value="<?php echo $project_id; ?>" /> 
		<input type="hidden" name="task_invoice" value="<?php echo $invoice_id; ?>" />
		<input type="hidden" name="project_creator" value="<?php echo $AppUI->user_id; ?>" />

	<table width="100%" border="0" cellpadding="2" cellspacing="1" class="tbl">
		<tr>
			<th><?php	echo $AppUI->_('Select')?></th>
			<th><?php	echo $AppUI->_('Date') ?></th>
			<th colspan="2"><?php	echo $AppUI->_('Log Summary'); ?></th>
			<th nowrap="nowrap"><?php	echo $AppUI->_('Creator'); ?></th>
			<th nowrap="nowrap"><?php	echo $AppUI->_('Hours'); ?></th>
			<th nowrap="nowrap"><?php	echo $AppUI->_('Billing Code'); ?></th>
			<th nowrap="nowrap"><?php	echo $AppUI->_('Fixed Amount'); ?></th>
		</tr>
<?php
foreach ($tasks_log as $task_log)
	if ($task_log['task_log_id'] != 0)
		showtasklog($task_log, 1);
?>
<tr>
			<td><?php echo $AppUI->_('item'); ?></td>
			<td nowrap><?php
			$date = new CDate();
			echo $date->format($df);
			?></td>
			<td colspan="2"><input type="text" name="item_description[]" /></td>
			<td nowrap>&nbsp;</td>
			<td nowrap>&nbsp;</td>
			<td nowrap>&nbsp;</td>
			<td align="right" nowrap="nowrap">
				<?php echo dPgetConfig('currency_symbol'); ?>
				<input type="text" name="task_amount[]" size="6">
			</td>
		</tr>
		<tr>
			<td><input type="checkbox" name="checkall" onclick="checkUncheckAll(this);" /><?php
			echo $AppUI->_('all');
			?></td>
			<td><input class="text" type="button" name="add" value="add item" onclick="addRow(this.parentNode.parentNode)"></td>
		</tr>
	</table>

		<br />
		<input class="button" type="button" name="btnFuseAction" value="<?php echo $AppUI->_('Add selected tasks log to invoice'); ?>" onclick="submitIt();" />
		<br /><br />

	</form>
	<script type="text/javascript">
function addRow(row)
{
	var table = row.parentNode.parentNode;
	var pos = row.rowIndex;

	var i = 0;

	var row = table.insertRow(pos);
	var cell = row.insertCell(i++);
	cell.innerHTML = '<?php echo $AppUI->_('item');	?>';
	cell = row.insertCell(i++);
	cell.innerHTML = '<?php	echo $date->format($df); ?>';
	cell = row.insertCell(i++);
	cell.colSpan = 2;
	cell.innerHTML = '<input type="text" name="item_description[]" />';
	cell = row.insertCell(i++);
	cell = row.insertCell(i++);
	cell = row.insertCell(i++);
	cell = row.insertCell(i++);
	cell.setAttribute('align', 'right');
	cell.setAttribute('nowrap', 'nowrap');
	cell.innerHTML = '<?php echo dPgetConfig('currency_symbol'); ?> <input type="text" name="task_amount[]" size="6">';
}
</script>
* <?php echo $AppUI->_('requiredField');?>
