<?php
/* This file will write a php config file to be included during execution of
 * all invoice files which require the configuration options. */

// Deny all but system admins
if (getDenyEdit('system')) {
	$AppUI->redirect( "m=public&a=access_denied" );
}

@include_once( "./functions/admin_func.php" );

$CONFIG_FILE = "./modules/invoice/config.php";

$AppUI->savePlace();


// Get a list of companies
$sql = "SELECT company_id, company_name
        FROM companies
        ORDER BY company_name";

$res = db_exec($sql);

// Add "No Company"
$companies['-1'] = '';

while ($row = db_fetch_assoc($res)) {
  $companies[$row['company_id']] = $row['company_name'];
}

//define user type list
$user_types = arrayMerge( $utypes, array( '9' => $AppUI->_('None') ) );

/* All config options, their descriptions and their default values are defined
* here. Add new config options here. Type can be "checkbox", "text", "radio" or
* "select". If the type is "radio," it must include a set of buttons. If it's
* "select" then be sure to include a 'list' entry with the options.  if the key
* starts with headingXXX then it will just display the contents on the value.
* This is used for grouping.
*/
$config_options = array(
	"heading1" => $AppUI->_('Project Tasks Billing'),
	"complete_tasks_only" => array(
		"description" => $AppUI->_('Show TaskLogs for complete tasks only'),
		"value" => 1,
		'type' => 'checkbox'
	),
	'heading2' => $AppUI->_('Tax'),
	"tax" => array(
		"description" => $AppUI->_('Tax Rate'),
		"value" => 0.05,
		'type' => 'text'
	),
	'heading3' => $AppUI->_('Email Settings'),
	"email" => array(
		"description" => $AppUI->_('Email sent from this address'),
		"value" => 'billing@example.com',
		'type' => 'text'
	),
);

//if this is a submitted page, overwrite the config file.
if(dPgetParam( $_POST, "Save", '' )!=''){

	if (is_writable($CONFIG_FILE)) {
		if (!$handle = fopen($CONFIG_FILE, 'w')) {
			$AppUI->setMsg( $CONFIG_FILE." ".$AppUI->_('cannot be opened'), UI_MSG_ERROR );
			exit;
		}

		if (fwrite($handle, "<?php //Do not edit this file by hand, it will be overwritten by the configuration utility. \n") === FALSE) {
			$AppUI->setMsg( $CONFIG_FILE." ".$AppUI->_('cannot be written to'), UI_MSG_ERROR );
			exit;
		} else {
			foreach ($config_options as $key=>$value){
			  if(substr($key,0,7)=='heading') continue;

				$val="";
				switch($value['type']){
					case 'checkbox': 
						$val = isset($_POST[$key])?"1":"0";
						break;
					case 'text': 
						$val = isset($_POST[$key])?$_POST[$key]:"";
						break;
					case 'select': 
						$val = isset($_POST[$key])?$_POST[$key]:"0";
						break;
					case 'radio':
						$val = $_POST[$key];
						break;
					default:
						break;
				}
				
				fwrite($handle, "\$INVOICE_CONFIG['".$key."'] = '".$val."';\n");
			}

			fclose($handle);
			$AppUI->setMsg( $CONFIG_FILE." ".$AppUI->_('has been successfully updated'), UI_MSG_OK );
			require( $CONFIG_FILE );
		}
	} else {
		$AppUI->setMsg( $CONFIG_FILE." ".$AppUI->_('is not writable'), UI_MSG_ERROR );
	}
} else if(dPgetParam( $_POST, $AppUI->_('cancel'), '' )!=''){
	$AppUI->redirect("m=system&a=viewmods");
}

//$INVOICE_CONFIG = array();
require_once( $CONFIG_FILE );

//Read the current config values from the config file and update the array.
foreach ($config_options as $key=>$value){
	if(isset($INVOICE_CONFIG[$key])){

		$config_options[$key]['value']=$INVOICE_CONFIG[$key];
	}
}

// setup the title block
$titleBlock = new CTitleBlock( 'Configure Invoice Module', 'invoice.png', $m, "$m.$a" );
$titleBlock->addCrumb( "?m=system", "System Admin" );
$titleBlock->addCrumb( "?m=system&a=viewmods", "Modules" );
$titleBlock->show();

?>

<form method="post">
<table class="std">
<?php
foreach ($config_options as $key=>$value){
?>
	<tr>
		<?php
    // the key starts with hr, then just display the value
	  if(substr($key,0,7)=='heading'){ ?>
		  <th align="center" colspan="2"><?php echo $value?></th>
		<?php } else { ?>
		<td align="right"><?php echo $value['description']?></td>
		<td><?php
      switch($value['type']){
        case 'checkbox': ?>
          <input type="checkbox" name="<?php echo $key?>" <?php echo $value['value']?"checked=\"checked\"":""?>>
          <?php
          break;
        case 'text': ?>
          <input type="text" name="<?php echo $key?>" value="<?php echo $value['value']?>">
          <?php
          break;
        case 'select': 
          print arraySelect( $value["list"], $key, 'class="text" size="1" id="' . $key . '" ' . $value["events"], $value["value"] );
          break;
        case 'radio':
          foreach ($value['buttons'] as $v => $n) {?>
            <label><input type="radio" name="<?php echo $key; ?>" id="<?php echo $key; ?>" value=<?php echo $v; ?> <?php echo (($value['value'] == $v)?"checked":""); ?> <?php echo $value['events']; ?>> <?php echo $n;?></label>
          <?php }
          break;
        default:
          break;
      }
		?></td>
		<?php
			}
		?>
	</tr>
<?php	
}
?>
	<tr>
		<td colspan="2" align="right"><input type="Submit" name="Cancel" value="<?php echo $AppUI->_('back')?>">
                                  <input type="Submit" name="Save" value="<?php echo $AppUI->_('save')?>"></td>
	</tr>
</table>
</form>
