<?php
if (! defined('DP_BASE_DIR')) {
	die('You should not access this file directly');
}

$del   = dPgetParam($_POST, 'del', 0);
$stat  = dPgetParam($_POST, 'invoice_status', - 1);
$purge = dPgetParam($_POST, 'delinvoice', 0);
$invoice_id = dPgetParam($_POST, 'task_invoice', 0);

$obj = new CInvoice();

if (! $obj->bind($_POST)) {
	$AppUI->setMsg($obj->getError(), UI_MSG_ERROR);
	$AppUI->redirect();
}
$obj->task_invoice = $invoice_id;

$AppUI->setMsg('Invoice');
if ($del) {
	if (($msg = $obj->delete())) {
		$AppUI->setMsg($msg, UI_MSG_ERROR);
	} else {
		$AppUI->setMsg("item deleted", UI_MSG_OK, true);
	}
	
	$AppUI->redirect("m=invoice&a=addedit&invoice_id=" . $obj->task_invoice . "&project_id=" . $obj->_invoice_project);
} elseif ($purge) {
	if (($msg = $obj->purge()))
		$AppUI->setMsg($msg, UI_MSG_ERROR);
	else
		$AppUI->setMsg("deleted", UI_MSG_OK, true);
	
	$AppUI->redirect("m=invoice");
} elseif ($stat != -1 && $obj->task_invoice != 0) {
	if (($msg = $obj->change_status($_POST)))
		$AppUI->setMsg($msg, UI_MSG_ERROR);
	else
		$AppUI->setMsg($msg . 'updated', UI_MSG_OK, true);
	
	$AppUI->redirect('m=invoice&a=addedit&invoice_id=' . $obj->task_invoice . '&project_id=' . $obj->_invoice_project);
} else { // Addedit page
	$msg = $obj->check();

	
	// Clear the description for tasklogs (otherwise it's bound above)
	$obj->item_description = '';
	$total = 0;
	if (!empty($_POST['num'])) {
		foreach ($_POST['num'] as $task_log_id) {
			// $obj->task_invoice would have been generated by the line above, don't reset it.
			$obj->task_log_id = $task_log_id;
			$obj->task_amount = $_POST["fixed_" . $task_log_id];
			$obj->store();
			if ($_POST["fixed_" . $task_log_id] > 0) {
				$total += $_POST["fixed_" . $task_log_id];
			} else {
				$total += calc_cost($task_log_id, $obj->_invoice_project);
			}
		}
	}
	
	if ($_POST['item_description']) {
		foreach ($_POST['item_description'] as $k => $item) {
			if (! empty($item)) {
				$obj->item_description = stripslashes($item);
				$obj->task_amount = $_POST['task_amount'][$k];
				$obj->store();
				$total += $_POST['task_amount'][$k];
			}
		}
	}
	
	$obj->setTotal($total);
	
	//$obj->send();
	$AppUI->setMsg($msg . 'updated', UI_MSG_OK, true);
	$AppUI->redirect('m=invoice&a=addedit&invoice_id=' . $obj->task_invoice . '&project_id=' . $obj->_invoice_project);
}

function calc_cost($task_log_id, $project_id) {
	$q = new DBQuery;
	$q->addQuery('project_company');
	$q->addTable('projects');
	$q->addWhere('project_id = '. $project_id);
	$company_id = $q->loadResult();
	
	if (!$company_id)
		$company_id = 0;

	$q->addQuery('billingcode_id, billingcode_name, billingcode_value');
	$q->addTable('billingcode');
	$q->addWhere('(company_id = 0 OR company_id = ' . $company_id . ')');
	$q->addOrder('billingcode_name ASC');
	$billingcodes = $q->loadList();
	
	$rate = 0;
	$q->addQuery('task_log_costcode as costcode');
	$q->addQuery('task_log_hours as hours');
	$q->addTable('task_log');
	// Only show tasklogs that map to tasks! (deleted tasks won't show)
	$q->addJoin('tasks', 't', 'task_log_task = task_id');
	$q->addWhere('task_log_id = ' . $task_log_id);
	list($cost) = $q->loadList();
	
	foreach ($billingcodes as $bcode) 
		if ($bcode['billingcode_id'] == $cost['costcode'])
			$rate = $bcode['billingcode_value'];

	return round($rate * $cost['hours'], 2);
}