<?php
if (!defined('DP_BASE_DIR')){
	die('You should not access this file directly');
}

require_once( $AppUI->getSystemClass( 'libmail' ) );
require_once( $AppUI->getSystemClass( 'dp' ) );
include_once("./modules/invoice/config.php");

class CInvoice extends CDpObject {

	var $invoice_task_queue_id = NULL;
	var $task_invoice = NULL;
	var $task_log_id = 0;
	var $task_amount = NULL;
	var $item_description = '';

	function CInvoice()
	{
		$this->CDpObject('invoice_task_queue', 'task_invoice');
		$this->_invoice_project=$_POST["invoice_project"];
		$this->_task_queue_id=$_POST["task_queue_id"];
	}

	function check() 
	{
		if ($this->task_invoice == NULL || $this->task_invoice == "0")
			$this->init();
		
		if (empty($this->task_amount))
			$this->task_amount = '0';

		return NULL;
	}

	function init() 
	{
		$q = new DBQuery;
		$q->addTable('invoice');
		$q->addInsert('invoice_project,invoice_date,invoice_creator', $_POST['invoice_project'].','.time().','.$_POST['project_creator'], true);
		$q->exec();
		$this->task_invoice = db_insert_id();
	}
	
	function setTotal($subtotal, $tax = -1) 
	{
		global $INVOICE_CONFIG;
		if ($tax == -1) {
			$tax = $subtotal * $INVOICE_CONFIG['tax'];
		}
		
		$q = new DBQuery;
		$q->addTable('invoice');
		$q->addUpdate('invoice_tax,invoice_total', array($tax, $subtotal + $tax), true);
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		$q->exec();
	}

	function store() 
	{
		$msg = $this->check();
		$q = new DBQuery;
		$q->addTable('invoice_task_queue');
		$q->addInsert('task_invoice', $this->task_invoice);
		$q->addInsert('task_amount', $this->task_amount);
		$q->addInsert('task_log_id', $this->task_log_id);
		$q->addInsert('item_description', $this->item_description);
		$q->exec();
	}

	function delete() 
	{
		$this->_action='deleted';
		$q = new DBQuery();
		$q->setDelete('invoice_task_queue');
		$q->addWhere('task_queue_id = ' . $this->_task_queue_id);
		if (!$q->exec())
			return db_error();
		else
			return NULL;
	}

	function purge() 
	{
		$this->_action='purged';
		$q = new DBQuery;
		$q->addQuery('invoice_status');
		$q->addTable('invoice');
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		$temp_array= $q->loadList();
		$mystatus=$temp_array[0]["invoice_status"];
		if ($mystatus == 0) 
		{
			$q->clear();	
			$q->setDelete('invoice_task_queue');
			$q->addWhere('task_invoice = ' . $this->task_invoice);
			$q->exec();
		} 
		else 
		{
			$q->clear();
			$q->addTable('tasks');
			$q->addUpdate('task_invoice', '0');
			$q->addUpdate('task_cost' , '0');
			$q->addWhere('task_invoice = ' . $this->task_invoice);
			$q->exec();
		}

		$q->clear();
		$q->setDelete('invoice');
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		if (!$q->exec())
			return db_error();
		else
			return NULL;
	}

	function change_status($changes)
	{
		$this->_action='updated';
		$q = new DBQuery;
		$q->addTable('invoice');
		$q->addUpdate('invoice_status', $changes['invoice_status']);
		$q->addUpdate('invoice_contact', $changes['invoice_contact']);
		$q->addUpdate('invoice_notes', $changes['invoice_notes']);
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		$q->exec();
		$q->clear();
	}
	
	function addTask($item, $price)
	{
		$q = new DBQuery();
		$q->addInsert('item_description', $item);
		$q->addInsert('task_queue_id', $this->task_queue_id);
		$q->addInsert('task_invoice', $this->task_invoice);
		$q->addInsert('task_amount', $price);
		$q->addTable('invoice_task_queue');
		$q->exec();
	}

	function process_queue($module, $type, $company_id, $owner, $args)
	{
		$q = new DBQuery();
		$q->addQuery('invoice_sentdate');
		$q->addTable('invoice_company');
		$q->addWhere('invoice_company = ' . $company_id);
		$date = $q->loadResult();

		if (date('Y-m-d') > $date)
			return true;
		else
		{
			$q = new DBQuery;
			$q->addTable('invoice');
			$q->addInsert('invoice_project,invoice_date,invoice_creator', '-' . $company_id . ','.time().', 0, true');
			$q->exec();
			$this->task_invoice = db_insert_id();
										
			$this->send();
		}
		
	}
	
	function send_monthly($company_id)
	{
		$q = new DBQuery();
		$q->addQuery('company_id');
		$q->addQuery('invoice_email');
		$q->addQuery('invoice_sentdate');
		$q->addTable('invoice_company');
		$q->addWhere('invoice_company = ' . $company_id);
										
	}
	
	function send($overdue = 0)
	{
		global $baseDir, $INVOICE_CONFIG;
	
		$q = new DBQuery();
	
		$q->addTable('invoice');
		$q->addUpdate('invoice_status', '1');
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		$q->exec();
		$q->clear();
		
		$q->addQuery('company_id');
		$q->addQuery('invoice_email');
		$q->addQuery('invoice_sentdate');
		$q->addTable('companies');
		$q->addJoin('invoice_company', 'ic', 'ic.invoice_company = company_id');
		$q->addJoin('projects', 'p', 'p.project_company = company_id');
		$q->addJoin('invoice', 'i', '(i.invoice_project = p.project_id OR i.invoice_project = -1 * company_id)');
		$q->addWhere('invoice_id = ' . $this->task_invoice); 
		list($row) = $q->loadList();
		$company_email = $row['invoice_email'];
		$last_date = $row['invoice_sentdate'];
		$company_id = $row['company_id'];
		
		// Look for repeating invoices
		if (!$last_date || $last_date < date('Y-m-d', time() - (30*24*3600)))
		{
			$q->addQuery('item, amount');
			$q->addTable('invoice_company_items');
			$q->addWhere('company = ' . $company_id);
			$recurring_items = $q->loadList();
			
			foreach($recurring_items as $item)
				$this->addTask($item['item'], $item['amount']);
		}
		
		$q->addQuery('invoice_email_name');
		$q->addTable('invoice_company');
		$q->addWhere('invoice_company = ' . $company_id);
		$contact = $q->loadResult();
		
		if (empty($contact))
		{
			$q->addQuery('invoice_contact');
			$q->addTable('invoice');
			$q->addWhere('invoice_id = ' . $this->task_invoice);
			$contact = $q->loadResult();
		}
		
		$mail = new Mail();
		$mail->Subject('Project Invoice #' . $this->task_invoice);
		$mail->From($INVOICE_CONFIG['email']);
		$mail->To($company_email);
//		$mail->Bcc($INVOICE_CONFIG['email']);
		$file = $this->pdfReport();
		$mail->Attach($baseDir . $file, 'application/pdf', 'inline');
		
		
		
		$body = '
<p>Dear ' . $contact . ',</p>
 
';
		if ($overdue == 0)
			$body .= '
<p>Attached please find our latest invoice for services rendered.</p>

<p>Please let us know if you have any questions.</p>
';
		elseif ($overdue == 1)
			$body .= '
<p>We sent you an invoice for services rendered 2 weeks ago. We have not received payment yet. Please find the invoice attached.</p>

<p>Please submit your payment immediately.</p>
';
		elseif ($overdue == 2)
			$body .= '
<p>We already sent you a reminder 2 weeks ago. We have still not received a
payment. This invoice has now been due for 4 weeks. Please find it attached.</p>

<p>Please submit your payment immediately.</p>
';
		$body .= ' 
<pre>
_________________________________

Billing Department
</pre>
';
		
		$mail->Body($body);
		$mail->Send();
		
		$q->addTable('invoice_company');
		$q->addUpdate('invoice_sentdate', date('Y-m-d'));
		$q->addWhere('invoice_company', $company_id);
		$q->exec();
	}
	
	function pdfReport()
	{
		global $AppUI, $baseDir;
		$q = new DBQuery;
	
		$q->addQuery('invoice_project');
		$q->addTable('invoice');
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		$project_id = $q->loadResult();
		$invoice_id = $this->task_invoice;
		
		$df = $AppUI->getPref('SHDATEFORMAT');
		$df = '%m/%d/%Y';
		
		// Invoice info
		$q->addQuery('*');
		$q->addTable('invoice');
		$q->addWhere('invoice_id = ' . $invoice_id);
		list($invoice) = $q->loadList();
		
		// Get Current Company Information
		$q->addQuery('
				company_name, 
				company_address1, 
				company_address2,
				company_city,
				company_state,
				company_zip,
				company_phone1,
				company_fax');
		$q->addTable('companies');
		$q->leftJoin('config', 'c', 'company_name = config_value');
		$q->addWhere('c.config_name = \'company_name\'');
		//$srcComp = $q->loadHash();
		$srcComp = null;
		db_loadHash($q->prepare(), $srcComp);
		
		$address = '';
		$contact = '
		<c:alink:http://www.dotproject.net/>www.dotproject.net</c:alink>';
		$table_address = array(array($address, $contact));
		
		
		// Get Customer Information
		$q = new DBQuery;
		$q->addQuery('company_id, company_name');
		$q->addQuery('company_address1, company_address2');
		$q->addQuery('company_city');
		$q->addQuery('company_state, company_zip');
		
		$q->addTable('companies');
		$q->leftJoin('projects', 'p', 'project_company = company_id');
		$q->addWhere('p.project_id = ' . $project_id);
		$client = $q->loadHash(); 

		$q->addQuery('invoice_name');
		$q->addTable('invoice_company');
		$q->addWhere('invoice_company = ' . $client['company_id']);
		$contact = $q->loadResult();
		if ($contact)
			$client_address = $contact . "\n";
		else	
			$client_address = $invoice['invoice_contact'] . "\n";
		$client_address .= $client['company_name'] . "\n";
		$client_address .= $client['company_address1'] . "\n";
		if ($client['company_address2'])
			$client_address .= $client['company_address2'] . "\n";
		$client_address .= $client['company_city'] . ', ' .  $client['company_state'] . ' ' . $client['company_zip'] . "\n";
		
		// Invoice Data!
		$pdfheaders = array(
		    'date' => 'Date',
		    'task' => 'Task Description',
		    'hours' => 'Hours',
				'type' => 'Task Type',
		    'total' => 'Amount');
		
		//--  get some data
		$q = new DBQuery;
		$q->addQuery('task_amount');
		$q->addQuery('invoice_task_queue.task_log_id');
		//$q->addQuery('task_log_description as name');
		$q->addQuery('task_name as name');
		$q->addQuery('task_log_date');
		$q->addQuery('task_log_hours');
		$q->addQuery('task_log_costcode');
		$q->addQuery('billingcode_value, billingcode_name');
		
		$q->addTable('invoice_task_queue');
		$q->addTable('task_log');
		$q->addJoin('tasks', 't', 't.task_id = task_log_task');
		$q->leftJoin('billingcode', 'b', 'b.billingcode_id = task_log_costcode');
		
		$q->addWhere('task_invoice = ' . $invoice_id);
		$q->addWhere('task_log.task_log_id = invoice_task_queue.task_log_id');
		$q->addOrder('task_log_date');
		
		$pname = $q->loadList();
		
		$q->addQuery('task_amount');
		$q->addQuery('item_description as name');
		$q->addTable('invoice_task_queue');
		$q->addWhere('task_log_id = 0');
		$q->addWhere('task_invoice = ' . $invoice_id);
		$invoices = $q->loadList();
		
		$pname = array_merge($pname, $invoices);
		
		$pdfdata = array();
		$invTotal = 0;
		$hoursTotal = 0;
		
		$pdfdata = array();
		foreach ($pname as $inv) {
			$d = new CDate($inv['task_log_date']); 
			if ($inv['task_amount'] != 0)
				$amt = $inv['task_amount'];
			else
				$amt = round($inv['billingcode_value'] * $inv['task_log_hours'], 2);
			$dispAmt = dPgetConfig('currency_symbol') . sprintf("%.2f", $amt, 2);
			$invTotal = $invTotal + $amt;
			$hoursTotal += $inv['task_log_hours'];
			
			$pdfdata[] = array(
					'date' => $d->format($df),
					'task' => $inv['name'],
					'hours' => ($inv['task_log_hours'] > 0?sprintf("%.2f", $inv['task_log_hours'], 2):'-'),
					'type' => $inv['billingcode_name'],
					'total' => $dispAmt    );
		}
		
		// Get Header information
		$header = array();
		$date = new Date();
		$header[] = array('Date: ', $date->format($df));
		$header[] = array('Invoice #:', $invoice_id);
		$header[] = array('Term: ', 'Upon receipt');
		$header[] = array('Total due: ', dPgetConfig('currency_symbol') . $invTotal);
		
		
		// Other Settings
		$font_dir = dPgetConfig( 'root_dir' ).'/lib/ezpdf/fonts';
		$temp_dir = dPgetConfig( 'root_dir' ).'/files/temp';
		$base_url  = dPgetConfig( 'base_url' );
		require_once( $AppUI->getLibraryClass( 'ezpdf/class.ezpdf' ) );
		
		
		// PDF Creation
		
		$pdf =& new Cezpdf('letter', 'portrait');
		
		$pdf->ezSetCmMargins( 2.54, 2.54, 3.17, 3.17 );
		$pdf->selectFont( "$font_dir/Helvetica.afm" );
		//$pdf->selectFont( "$font_dir/arial.pfb" );
		
		// Header
		$pdf->ezImage($baseDir.'/modules/invoice/images/logo.png', 0, 0, 'none', 'left');
		
		$pdf->setColor(0, 0, 0);
		$pdf->ezText('INVOICE #' . $invoice_id);
		
		$line_pos = 684;
		$pdf->line(50, $line_pos, 550, $line_pos);
		$pdf->ezSetDy(-10);
		
		
		// Address info
		$pdf->ezSetDy(-12);
		$pdf->ezText($client_address, 12);
		
		$options = array(
		'showLines' => 0,
		'showHeadings' => 0,
		'rowGap' => 0, 
		'fontSize' => 10,
		'shaded' => 0,
		'xPos' => 'left',
		'xOrientation' => 'right'
		);
		$pdf->ezSetDy(-24);
		$pdf->ezTable($header, '', '', $options);
		
		//$title = 'Title';
		//$pdf->ezSetDy(-20);
		//$pdf->ezText('<b>' . $title . '</b>');
		$pdf->ezSetDy(-20);
		
		
		// Invoice
		
		$pdf->ezText('<u>Details:</u>', 10);
		
		$options = array(
			'showLines' => 2,
			'showHeadings' => 1,
			'fontSize' => 10,
			'rowGap' => 2,
			'colGap' => 5,
			'shaded' => 0,
			'xPos' => 'left', //142,
			'xOrientation' => 'right',
			'width'=>450,
			
			'cols'=>array(
				'date' => array('width'=>40),
				'task' => array('width'=>230),
				'hours' => array('justification'=>'center', 'width'=>40),
				'type' => array('width'=>100),
				'total' => array('width'=>40))
		);
		
		// print the table
		$pdf->ezSetDy(-20);
		$pdf->ezTable( $pdfdata, $pdfheaders,'',$options );
		$pdf->ezSetDy(-20);
		
		
		// Closing info
		$pdf->ezText('Total amount due: <u><b>' . dPgetConfig('currency_symbol') . sprintf('%.2f', $invTotal) . '</b></u>');
		
		$pdf->ezSetDy(-30);
		$pdf->ezText('<u>Notes:</u>');
		$pdf->ezText('' . $invoice['invoice_notes']);
		
		$pdf->reopenObject($pdf->getFirstPageId());
		$pdf->ezSetY(730);
		$options = array(
		'showHeadings' => 0, 
		'textCol' => array(0.2, 0.4, 0.6), 
		'fontSize' => 6,
		'xPos' => 'right', 
		'xOrientation' => 'left',
		'lineCol' => array(0.7, 0.7, 0.7),
		'innerLineThickness' => 0.2,
		'outerLineThickness' => 0.2,
		);
		$pdf->ezTable($table_address, '', '', $options);
		
		$pdf->ezSetCmMargins( 2.54, 1, 3.17, 3.17 );
		$pdf->ezSetY(50);
		$pdf->ezText('Thank you for doing business with us', 14, array('justification' => 'center'));
		
		$file = 'Invoice_' .  $invoice_id  . str_replace(' ', '_', $client['company_name']) . '.pdf';
		$options = array (
			'Content-Disposition' => $file
		);
		
		$file = '/files/temp/' . $file;
		if ($fp = fopen( $baseDir . $file, 'wb' )) 
		{
			fwrite($fp, $pdf->ezOutput());
			fclose($fp);
		}
		else
			echo 'Can\'t open file ' . $baseDir. $file;

		return $file;
	}
}
