<?php
if (!defined('DP_BASE_DIR')){
	die('You should not access this file directly');
}

$project_id = intval( dPgetParam( $_GET, 'project_id', 0 ) );
$invoice_id = intval( dPgetParam( $_GET, 'invoice_id', 0 ) );
$invoice_to = intval( dPgetParam( $_GET, 'invoice_to', 0 ) );
$tasks = intval( dPgetParam( $_GET, 'tasks', 0 ) );

$df = $AppUI->getPref('SHDATEFORMAT');

$q = new DBQuery;
// Invoice info
$q->addQuery('*');
$q->addTable('invoice');
$q->addWhere('invoice_id = ' . $invoice_id);
list($invoice) = $q->loadList();

//--  get some data
$q = new DBQuery;
$q->addQuery('task_amount');
$q->addQuery('invoice_task_queue.task_log_id');
//$q->addQuery('task_log_description as name');
$q->addQuery('task_name as name');
$q->addQuery('task_log_date');
$q->addQuery('task_log_hours');
$q->addQuery('task_log_costcode');
$q->addQuery('billingcode_value, billingcode_name');

$q->addTable('invoice_task_queue');
$q->addTable('task_log');
$q->addJoin('tasks', 't', 't.task_id = task_log_task');
$q->leftJoin('billingcode', 'b', 'b.billingcode_id = task_log_costcode');

$q->addWhere('task_invoice = ' . $invoice_id);
$q->addWhere('task_log.task_log_id = invoice_task_queue.task_log_id');
$q->addOrder('task_log_date');

$pname = $q->loadList();

$q->addQuery('task_amount');
$q->addQuery('item_description as name');
$q->addTable('invoice_task_queue');
$q->addWhere('task_log_id = 0');
$q->addWhere('task_invoice = ' . $invoice_id);
$invoices = $q->loadList();

$pname = array_merge($pname, $invoices);

$pdfdata = array();
$invTotal = 0;
$hoursTotal = 0;

// Invoice Data!
$pdfdata = array(array(
    'date' => 'Date',
    'task' => 'Task Description',
    'hours' => 'Hours',
		'type' => 'Task Type',
    'total' => 'Amount'));
foreach ($pname as $inv) {
	$d = new CDate($inv['task_log_date']); 
	if ($inv['task_amount'] != 0)
		$amt = $inv['task_amount'];
	else
		$amt = round($inv['billingcode_value'] * $inv['task_log_hours'], 2);
	$dispAmt = dPgetConfig('currency_symbol') . sprintf("%.2f", $amt, 2);
	$invTotal = $invTotal + $amt;
	$hoursTotal += $inv['task_log_hours'];
	
	$pdfdata[] = array(
			'date' => $d->format($df),
			'task' => safe_utf8_decode($inv['name']),
			'hours' => ($inv['task_log_hours'] > 0?sprintf("%.2f", $inv['task_log_hours'], 2):'-'),
			'type' => safe_utf8_decode($inv['billingcode_name']),
			'total' => $dispAmt    );
}

// Get Header information

$fp = tmpfile();
foreach ($pdfdata as $row) {
	fputcsv($fp, $row);
}
fseek($fp, 0);
$data = fread($fp, 10240);
fclose($fp);

$q->clear();
$q->addTable('projects');
$q->addQuery('project_short_name');
$q->addWhere('project_id = ' . $project_id);
$project_short_name = $q->loadResult();
$file = 'invoice-' .  $invoice_id  . '-'.str_replace(' ', '_', $project_short_name) . '.csv';
$options = array (
	'Content-Disposition' => $file
);

header('Content-type: text/csv');
header('Content-Disposition: attachment; filename="'.$file.'"');
echo $data;