<?php
if (!defined('DP_BASE_DIR')){
	die('You should not access this file directly');
}

$project_id = intval( dPgetParam( $_GET, 'project_id', 0 ) );
$invoice_id = intval( dPgetParam( $_GET, 'invoice_id', 0 ) );
$invoice_to = intval( dPgetParam( $_GET, 'invoice_to', 0 ) );
$tasks = intval( dPgetParam( $_GET, 'tasks', 0 ) );

$df = $AppUI->getPref('SHDATEFORMAT');

$q = new DBQuery;
// Invoice info
$q->addQuery('*');
$q->addTable('invoice');
$q->addWhere('invoice_id = ' . $invoice_id);
list($invoice) = $q->loadList();

// Get Current Company Information
$q->addQuery('
		company_name, 
		company_address1, 
		company_address2,
		company_city,
		company_state,
		company_zip,
		company_phone1,
		company_fax');
$q->addTable('companies');
$q->leftJoin('config', 'c', 'company_name = config_value');
$q->addWhere('c.config_name = \'company_name\'');
//$srcComp = $q->loadHash();
db_loadHash($q->prepare(), $srcComp);

$address = 'dotProject';
$contact = '
<c:alink:http://www.dotproject.net/>www.dotproject.net</c:alink>';
$table_address = array(array($address, $contact));


// Get Customer Information
$q = new DBQuery;
$q->addQuery('company_id, company_name');
$q->addQuery('company_address1, company_address2');
$q->addQuery('company_city');
$q->addQuery('company_state, company_zip');

$q->addTable('companies');
$q->leftJoin('projects', 'p', 'project_company = company_id');
$q->addWhere('p.project_id = ' . $project_id);
$client = $q->loadHash(); 
$client_address = $invoice['invoice_contact'] . "\n";
$client_address .= $client['company_name'] . "\n";
$client_address .= $client['company_address1'] . "\n";
if ($client['company_address2'])
	$client_address .= $client['company_address2'] . "\n";
$client_address .= $client['company_city'] . ', ' .  $client['company_state'] . ' ' . $client['company_zip'] . "\n";
$client_address = safe_utf8_decode($client_address);

// Invoice Data!
$pdfheaders = array(
    'date' => 'Date',
    'task' => 'Task Description',
    'hours' => 'Hours',
		'type' => 'Task Type',
    'total' => 'Amount');

//--  get some data
$q = new DBQuery;
$q->addQuery('task_amount');
$q->addQuery('invoice_task_queue.task_log_id');
//$q->addQuery('task_log_description as name');
$q->addQuery('task_name as name');
$q->addQuery('task_log_date');
$q->addQuery('task_log_hours');
$q->addQuery('task_log_costcode');
$q->addQuery('billingcode_value, billingcode_name');

$q->addTable('invoice_task_queue');
$q->addTable('task_log');
$q->addJoin('tasks', 't', 't.task_id = task_log_task');
$q->leftJoin('billingcode', 'b', 'b.billingcode_id = task_log_costcode');

$q->addWhere('task_invoice = ' . $invoice_id);
$q->addWhere('task_log.task_log_id = invoice_task_queue.task_log_id');
$q->addOrder('task_log_date');

$pname = $q->loadList();

$q->addQuery('task_amount');
$q->addQuery('item_description as name');
$q->addTable('invoice_task_queue');
$q->addWhere('task_log_id = 0');
$q->addWhere('task_invoice = ' . $invoice_id);
$invoices = $q->loadList();

$pname = array_merge($pname, $invoices);

$pdfdata = array();
$invTotal = 0;
$hoursTotal = 0;

$pdfdata = array();
foreach ($pname as $inv) {
	$d = new CDate($inv['task_log_date']); 
	if ($inv['task_amount'] != 0)
		$amt = $inv['task_amount'];
	else
		$amt = round($inv['billingcode_value'] * $inv['task_log_hours'], 2);
	$dispAmt = dPgetConfig('currency_symbol') . sprintf("%.2f", $amt, 2);
	$invTotal = $invTotal + $amt;
	$hoursTotal += $inv['task_log_hours'];
	
	$pdfdata[] = array(
			'date' => $d->format($df),
			'task' => safe_utf8_decode($inv['name']),
			'hours' => ($inv['task_log_hours'] > 0?sprintf("%.2f", $inv['task_log_hours'], 2):'-'),
			'type' => safe_utf8_decode($inv['billingcode_name']),
			'total' => $dispAmt    );
}

// Get Header information
$header = array();
$date = new CDate();
$header[] = array('Date: ', $date->format($df));
$header[] = array('Invoice #:', $invoice_id);
$header[] = array('Term: ', 'Upon receipt');
$header[] = array('Total due: ', dPgetConfig('currency_symbol') . $invTotal * (1 + $INVOICE_CONFIG['tax']));


// Other Settings
$font_dir = dPgetConfig( 'root_dir' ).'/lib/ezpdf/fonts';
$temp_dir = dPgetConfig( 'root_dir' ).'/files/temp';
$base_url  = dPgetConfig( 'base_url' );
require( $AppUI->getLibraryClass( 'ezpdf/class.ezpdf' ) );


// PDF Creation

$pdf =& new Cezpdf('letter', 'portrait');

$pdf->ezSetCmMargins( 2.54, 2.54, 3.17, 3.17 );
$pdf->selectFont( "$font_dir/Helvetica.afm" );
//$pdf->selectFont( "$font_dir/arial.pfb" );

// Header
if (is_file($baseDir.'/modules/invoice/images/logo.png'))
	$pdf->ezImage($baseDir.'/modules/invoice/images/logo.png', 0, 0, 'none', 'left');

$pdf->setColor(0, 0, 0);
$pdf->ezText('INVOICE #' . $invoice_id);

$line_pos = 684;
$pdf->line(50, $line_pos, 550, $line_pos);
$pdf->ezSetDy(-10);


// Address info
$pdf->ezSetDy(-12);
$pdf->ezText($client_address, 12);

$options = array(
'showLines' => 0,
'showHeadings' => 0,
'rowGap' => 0, 
'fontSize' => 10,
'shaded' => 0,
'xPos' => 'left',
'xOrientation' => 'right'
);
$pdf->ezSetDy(-24);
$pdf->ezTable($header, '', '', $options);

//$title = 'Title';
//$pdf->ezSetDy(-20);
//$pdf->ezText('<b>' . $title . '</b>');
$pdf->ezSetDy(-20);


// Invoice

$pdf->ezText('<u>Details:</u>', 10);

$options = array(
	'showLines' => 2,
	'showHeadings' => 1,
	'fontSize' => 10,
	'rowGap' => 2,
	'colGap' => 5,
	'shaded' => 0,
	'xPos' => 'left', //142,
	'xOrientation' => 'right',
	'width'=>450,
	
	'cols'=>array(
		'date' => array('width'=>40),
		'task' => array('width'=>230),
		'hours' => array('justification'=>'center', 'width'=>40),
		'type' => array('width'=>100),
		'total' => array('width'=>40))
);

// print the table
$pdf->ezSetDy(-20);
$pdf->ezTable( $pdfdata, $pdfheaders,'',$options );
$pdf->ezSetDy(-20);


// Closing info
$pdf->ezText('Subtotal: <u><b>' . dPgetConfig('currency_symbol') . sprintf('%.2f', $invTotal) . '</b></u>');
$pdf->ezText('Tax: <u><b>' . dPgetConfig('currency_symbol') . sprintf('%.2f', $invTotal * $INVOICE_CONFIG['tax']) . '</b></u>');
$pdf->ezText('Total amount due: <u><b>' . dPgetConfig('currency_symbol') . sprintf('%.2f', $invTotal * (1 + $INVOICE_CONFIG['tax'])) . '</b></u>');

$pdf->ezSetDy(-30);
$pdf->ezText('<u>Notes:</u>');
$pdf->ezText('' . safe_utf8_decode($invoice['invoice_notes']));

$pdf->reopenObject($pdf->getFirstPageId());
$pdf->ezSetY(730);
$options = array(
'showHeadings' => 0, 
'textCol' => array(0.2, 0.4, 0.6), 
'fontSize' => 6,
'xPos' => 'right', 
'xOrientation' => 'left',
'lineCol' => array(0.7, 0.7, 0.7),
'innerLineThickness' => 0.2,
'outerLineThickness' => 0.2,
);
$pdf->ezTable($table_address, '', '', $options);

$pdf->ezSetCmMargins( 2.54, 1, 3.17, 3.17 );
$pdf->ezSetY(50);
$pdf->ezText('Thank you for doing business with us', 14, array('justification' => 'center'));

$q->clear();
$q->addTable('projects');
$q->addQuery('project_short_name');
$q->addWhere('project_id = ' . $project_id);
$project_short_name = $q->loadResult();
$file = 'invoice-' .  $invoice_id  . '-'.str_replace(' ', '_', $project_short_name) . '.pdf';
$options = array (
	'Content-Disposition' => $file
);
$pdf->ezStream($options);