<?php
if (!defined('DP_BASE_DIR')){
	die('You should not access this file directly');
}

$project_id = intval( dPgetParam( $_GET, "project_id", 0 ) );
$invoice_id = intval( dPgetParam( $_GET, "invoice_id", 0 ) );
$invoice_to = intval( dPgetParam( $_GET, "invoice_to", 0 ) );
$tasks = intval( dPgetParam( $_GET, "tasks", 0 ) );

$invTitlePos    = 650;  // up/down where to begin printing theINVOICE header
$invToPos       = 600;  // up/down where to print the To: block
$invToInfoPos   = 570;  // up/down where to print the To: and Info data
$df = $AppUI->getPref('SHDATEFORMAT');

$font_dir = dPgetConfig( 'root_dir' )."/lib/ezpdf/fonts";
$temp_dir = dPgetConfig( 'root_dir' )."/files/temp";
$base_url  = dPgetConfig( 'base_url' );
require( $AppUI->getLibraryClass( 'ezpdf/class.ezpdf' ) );


$landscape = 0;
if ($landscape != 1)
    $pdf =& new Cezpdf("letter", "portrait");
else
    $pdf =& new Cezpdf("letter", "landscape");


$pdf->ezSetCmMargins( 1, 2, 1.5, 1.5 );
$pdf->selectFont( "$font_dir/Helvetica.afm" );


//
//  query the database for company info
//
$q = new DBQuery;
$q->addQuery('
        company_name,
        company_address1,
        company_address2,
        company_city,
        company_state,
        company_zip,
        company_phone1,
        company_fax');
$q->addTable('companies');
$q->leftJoin('config', 'c', 'company_name = config_value');
$q->addWhere('c.config_name = \'company_name\'');
//$srcComp = $q->loadHash();
db_loadHash($q->prepare(), $srcComp);




//================================================
//  Invoice details table
//================================================
//  set up the header array
$pdfheaders3 = array(
    'Date',
    'Log Item',
    'Description',
    'Price',
    'Hours',
    'Amount');

//--  get some data
$q = new DBQuery;
$q->addQuery('task_amount');
$q->addQuery('invoice_task_queue.task_log_id');
$q->addQuery('task_log_name');
$q->addQuery('task_log_description');
$q->addQuery('task_log_date');
$q->addQuery('task_log_hours');
$q->addQuery('task_log_costcode');
$q->addQuery('billingcode_value');

$q->addTable('invoice_task_queue');
$q->addTable('task_log');
$q->leftJoin('billingcode', 'b', 'b.billingcode_id = task_log_costcode');

$q->addWhere('task_invoice = ' . $invoice_id);
$q->addWhere('task_log.task_log_id = invoice_task_queue.task_log_id');
//$q->addWhere('billingcode.billingcode_id = task_log_costcode');

$pname = $q->loadList();
// create the array needed by ezTable
$pdfdata = array();
$invTotal = 0;
$hoursTotal = 0;

foreach ($pname as $inv) {
    $d = new CDate($inv['task_log_date']);
    if ($inv['task_amount'] > 0)
            $amt = $inv['task_amount'];
        else
            $amt = round($inv['billingcode_value'] * $inv['task_log_hours'], 2);
    $dispAmt = dPgetConfig('currency_symbol') . sprintf("%.2f", $amt, 2);
    $invTotal = $invTotal + $amt;
        $hoursTotal += $inv['task_log_hours'];

    $pdfdata[] = array(
        $d->format($df),
        safe_utf8_decode($inv['task_log_name']),
        safe_utf8_decode($inv['task_log_description']),
        (($inv['task_amount'] > 0)?'set':(dPgetConfig('currency_symbol').sprintf("%.2f",$inv['billingcode_value'], 2))),
        sprintf("%.2f", $inv['task_log_hours'], 2),
        $dispAmt    );
    }

// define the options for the table
$options = array(
            'showLines' => 1,
            'showHeadings' => 1,
            'fontSize' => 8,
            'rowGap' => 2,
            'colGap' => 5,
            'xPos' => 50,
            'xOrientation' => 'right',
            'width'=>'527',

'cols'=>array(
                0=>array('justification'=>'left','width'=>50),
                1=>array('justification'=>'left','width'=>150),
                2=>array('justification'=>'center','width'=>75),
                3=>array('justification'=>'center','width'=>75),
                4=>array('justification'=>'center','width'=>75))
            );

// print the table
$pdf->ezTable( $pdfdata, $pdfheaders3,'',$options );
$pdf->ezText('');
$pdf->ezText('');

// print the invoice total
$pdf->ezText("Total hours:           " . sprintf("%.2f",$hoursTotal), 12,
array('justification'=>'right'));
$pdf->ezText("Invoice Total:      " . dPgetConfig('currency_symbol').sprintf("%.2f",$invTotal,2), 12,
array('justification'=>'right'));

$q->clear();
$q->addTable('projects');
$q->addQuery('project_short_name');
$q->addWhere('project_id = ' . $project_id);
$project_short_name = $q->loadResult();
$file = 'invoice-' .  $invoice_id  . '-'.str_replace(' ', '_', $project_short_name) . '.pdf';
$options = array (
	'Content-Disposition' => $file
);
$pdf->ezStream($options);