<?php
if (!defined('DP_BASE_DIR')){
	die('You should not access this file directly');
}

/**
 * Name:      Invoice
 * Directory: invoice
 * Version:   0.7
 * Class:     user
 * UI Name:   Invoice
 * UI Icon:
 */

// MODULE CONFIGURATION DEFINITION
$config = array();
$config['mod_name'] = 'Invoice';
$config['mod_version'] = '0.7';
$config['mod_directory'] = 'invoice';
$config['mod_setup_class'] = 'CSetupInvoice';
$config['mod_type'] = 'user';
$config['mod_config'] = true;
$config['mod_ui_name'] = 'Invoice';
$config['mod_ui_icon'] = 'applet3-48.png';
$config['mod_description'] = 'A module for billing tasks';

if (@$a == 'setup') {
	echo dPshowModuleConfig( $config );
}


class CSetupInvoice{   

	function install() {
		$sql = "(
  `invoice_id` bigint(20) NOT NULL auto_increment,
  `invoice_project` int(11) NOT NULL default '0',
  `invoice_status` int(4) NOT NULL default '0',
  `invoice_date` int(11) NOT NULL default '0',
  `invoice_paid` int(11) default NULL,
  `invoice_creator` int(11) NOT NULL default '0',
	`invoice_contact` varchar(255) NOT NULL default '',
	`invoice_notes` text NOT NULL default '',
	`invoice_tax` DECIMAL( 10, 2 ) NOT NULL ,
  `invoice_total` DECIMAL( 10, 2 ) NOT NULL,
  PRIMARY KEY  (`invoice_id`)
) TYPE=MyISAM ";
		$q = new DBQuery;
		$q->createTable('invoice');
		$q->createDefinition($sql);
		$q->exec();

		$sql = '(
  `invoice_company` int(11) NOT NULL,
  `invoice_email` varchar(50) collate latin1_general_ci NOT NULL,
  `invoice_email_name` varchar(50) collate latin1_general_ci NOT NULL,
  `invoice_name` varchar(50) collate latin1_general_ci NOT NULL,
  `invoice_sendemail` tinyint(4) NOT NULL,
  `invoice_recur` tinyint(4) NOT NULL,
  `invoice_sentdate` date NOT NULL default \'0000-00-00\'
) ENGINE=MyISAM';
		$q->clear();
		$q->createTable('invoice_company');
		$q->createDefinition($sql);
		$q->exec();

		$sql = '(
  `company` int(11) NOT NULL,
  `item` varchar(255) collate latin1_general_ci NOT NULL,
  `amount` decimal(10,2) NOT NULL,
  KEY `company` (`company`)
) ENGINE=MyISAM ';
		$q->clear();
		$q->createTable('invoice_company_items');
		$q->createDefinition($sql);
		$q->exec();

		$sql = "(
  `task_queue_id` int(11) NOT NULL auto_increment,
  `task_invoice` int(11) NOT NULL default '0',
  `task_amount` float NOT NULL default '0',
  `task_log_id` bigint(20) NOT NULL default '0',
	`item_description` text,
  PRIMARY KEY  (`task_queue_id`)
) TYPE=MyISAM ";
		$q->clear();
		$q->createTable('invoice_task_queue');
		$q->createDefinition($sql);
		$q->exec();
		return null;
	}
	
	function remove() {
		$q = new DBQuery;

		$q->dropTable('invoice');
		$q->exec();
		$q->clear();

		$q->dropTable('invoice_task_queue');
		$q->exec();	
		
		return null;
	}
	
	function upgrade($version = 'all') {
		$q = new DBQuery;
		switch($version)
		{
			case 'all':
			case '0.1':
				$q->alterTable('invoice');
				$q->addField('invoice_contact', 'varchar(255)');
				$q->addField('invoice_notes', 'text');
				$q->exec();
				$q->clear();
				
				$q->alterTable('invoice_task_queue');
				$q->addField('item_description', 'text');
				$q->exec();
				$q->clear();
			case '0.6':
				$q->alterTable('invoice');
				$q->addField('invoice_tax', 'decimal(10,2)');
				$q->addField('invoice_total', 'decimal(10,2)');
			default:
				break;
		}
		return null;
	}
	
  /* NOTE: Configuration handling in dotProject is iffy at best. We're working
  with what we have *shrugs* */

  function configure() {
    global $AppUI;
    $AppUI->redirect("m=invoice&a=configure");

    return true;
  }
}